﻿Public Class Main
    Private IsSave As Boolean = True
    Private DatasForQuery()
    Private RequesterId As Integer = 0

    Private Sub Main_KeyDown(sender As Object, e As KeyEventArgs) Handles Me.KeyDown
        If e.Control AndAlso e.KeyCode = Keys.P Then
            PrintAllRequestersToolStripMenuItem_Click(sender, e)
        ElseIf e.KeyCode = Keys.F5 Then
            Main_Load(sender, e)
        End If
    End Sub

    Private Sub Main_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        DateRequestedDateTimePicker.MaxDate = Date.Now
        Dim Qry = "SELECT ID, Firstname AS [First Name], Lastname AS [Last Name], Purpose, NumberOfCopies AS [No of copies], DateRequested AS [Date Requested], PersonApproved AS [Approved by] FROM Logs"

        DbQuery(Qry, PrintingLogsDataGridView)
    End Sub

    Private Sub SaveButton_Click(sender As Object, e As EventArgs) Handles SaveButton.Click
        DatasForQuery = {FirstNameTextBox.Text, LastNameTextBox.Text, PurposeTextBox.Text, DateRequestedDateTimePicker.Value, PersonApprovedTextBox.Text, RequesterId, NumberOfCopiesTextBox.Text}

        Dim InsertRequesterQuery = String.Format("INSERT INTO Logs(Firstname, Lastname, Purpose, DateRequested, PersonApproved, NumberOfCopies) VALUES ('{0}', '{1}', '{2}', '{3}', '{4}', {6})", DatasForQuery)
        Dim UpdateRequesterQuery = String.Format("UPDATE Logs SET Firstname='{0}', Lastname='{1}', Purpose='{2}', DateRequested='{3}', PersonApproved='{4}', NumberOfCopies = {6} WHERE ID = {5}", DatasForQuery)

        If IsSave Then

            If FirstNameTextBox.Text.Equals("") And
            LastNameTextBox.Text.Equals("") And
            PurposeTextBox.Text.Equals("") And
            PersonApprovedTextBox.Text.Equals("") Then

                MessageBox.Show("Please fill in all the needed fields!", APP_NAME, MessageBoxButtons.OK, MessageBoxIcon.Warning)

            Else
                DbQuery(InsertRequesterQuery, PrintingLogsDataGridView, "Added a new requester successfully!")
                Main_Load(sender, e)
            End If
        Else
            DbQuery(UpdateRequesterQuery, PrintingLogsDataGridView, "Updated requester details successfully!")
            Main_Load(sender, e)
        End If

        AddNewRequesterButton.PerformClick()
        Main_Load(sender, e)
    End Sub

    Private Sub AddNewRequesterButton_Click(sender As Object, e As EventArgs) Handles AddNewRequesterButton.Click
        IsSave = True
        ClearAllInputFields(RequesterGroupBox)
    End Sub

    Private Sub PrintingLogsDataGridView_CellDoubleClick(sender As Object, e As DataGridViewCellEventArgs) Handles PrintingLogsDataGridView.CellDoubleClick, PrintingLogsDataGridView.CellDoubleClick, PrintingLogsDataGridView.CellClick
        IsSave = False

        RequesterId = PrintingLogsDataGridView.CurrentRow.Cells("ID").Value
        FirstNameTextBox.Text = PrintingLogsDataGridView.CurrentRow.Cells("First Name").Value
        LastNameTextBox.Text = PrintingLogsDataGridView.CurrentRow.Cells("Last Name").Value
        NumberOfCopiesTextBox.Text = PrintingLogsDataGridView.CurrentRow.Cells("No of copies").Value
        PurposeTextBox.Text = PrintingLogsDataGridView.CurrentRow.Cells("Purpose").Value
        DateRequestedDateTimePicker.Value = PrintingLogsDataGridView.CurrentRow.Cells("Date Requested").Value
        PersonApprovedTextBox.Text = PrintingLogsDataGridView.CurrentRow.Cells("Approved by").Value
    End Sub

    Private Sub PrintingLogsDataGridView_DataSourceChanged(sender As Object, e As EventArgs) Handles PrintingLogsDataGridView.DataSourceChanged
        If PrintingLogsDataGridView.RowCount.Equals(0) Then
            PrintingLogsDataGridView.DataSource = Nothing
            NoDataLabel.Show()
        Else
            NoDataLabel.Hide()
        End If
    End Sub

    Private Sub RefreshToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles RefreshToolStripMenuItem.Click
        Main_Load(sender, e)
    End Sub

    Private Sub PrintAllRequestersToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles PrintAllRequestersToolStripMenuItem.Click
        If PrintingLogsDataGridView.RowCount <= 0 Then
            MessageBox.Show("No data to print!" & vbNewLine & "Please put some requesters to be able to print.", APP_NAME, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        Else
            PrintReport("SELECT * FROM Logs", "PrintRequesters", AllRequesters.AllRequestersCrystalReportViewer)
            AllRequesters.ShowDialog()
        End If
    End Sub

    Private Sub Textbox_KeyDown(sender As Object, e As KeyEventArgs) Handles PurposeTextBox.KeyDown, PersonApprovedTextBox.KeyDown, NumberOfCopiesTextBox.KeyDown

        If e.KeyCode = Keys.Enter Then
            If NumberOfCopiesTextBox.Text = Nothing Then
                NumberOfCopiesTextBox.Text = 0
            Else
                SaveButton.PerformClick()
            End If
            Main_Load(sender, e)
        End If

    End Sub


    Private Sub DeleteRequesterToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles DeleteRequesterToolStripMenuItem.Click
        Dim ConfirmDelete = MessageBox.Show("Are you sure to delete requester " & FirstNameTextBox.Text & " " & LastNameTextBox.Text & "?", APP_NAME, MessageBoxButtons.YesNo, MessageBoxIcon.Question)

        If ConfirmDelete = vbYes Then
            DbQuery("DELETE FROM Logs WHERE ID = " & RequesterId)
            Main_Load(sender, e)
        End If
    End Sub

    Private Sub NumberOfCopiesTextBox_TextChanged(sender As Object, e As EventArgs) Handles NumberOfCopiesTextBox.TextChanged
        If Not IsNumeric(NumberOfCopiesTextBox.Text) Then
            NumberOfCopiesTextBox.Clear()
        End If
    End Sub
End Class
